#!/bin/bash
# Va à /opt/local/bin/sfs-combine.sh ou encore à /root/my-applications/bin/sfs-combine.sh.
#
# Usage : Mettez les sfs que vous voulez combiner dans /mnt/home,
# --------- ouvrez une console et tapez < sfs-combine.sh > (sans les chevrons).
#
####
# © Christian L'Écuyer, Gatineau (Qc), Canada, 2018-04-05. GPL3.
# (Alias musher0 [forum Puppy].) # Rev. : 2018-04-06.
##########  Please see: https://opensource.org/licenses/GPL-3.0.
#    Ce programme est libre : vous pouvez le redistribuer ou modifier selon les termes de la
#   Licence Publique Générale GNU publiée par la Free Software Foundation (v. 3 ou toute
#   version ultérieure choisie par vous).
#         Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE
#   GARANTIE, ni explicite ni implicite, y compris des garanties de commercialisation ou
#   d'adaptation à un but spécifique. Pour obtenir plus     de détails, veuillez vous reporter au
#   texte de cette licence à https://opensource.org/licenses/GPL-3.0 pour le texte officiel, à
#    http://www.linux-france.org/article/these/gpl.html pour une traduction et à
#    https://fr.wikipedia.org/wiki/Licence_publique_générale_GNU pour une explication en français.
################ set -xe
# LANGvx="$LANG";LANG=en_CA # for tests
nettoie () {
ls -1 --file-type /mnt/zip > /mnt/home/mnt-zip.lst
while read line;do umount /mnt/zip/$line;done < /mnt/home/mnt-zip.lst
rm -fr /mnt/zip/*
rmdir --ignore-fail-on-non-empty /mnt/zip/* 2>/dev/null
[ -d /mnt/home/tentative ] || mkdir -p /mnt/home/tentative
rm -fr /mnt/home/tentative/*
rmdir --ignore-fail-on-non-empty /mnt/home/tentative/* 2>/dev/null; }
cd /mnt/home

nettoie
clear
combien=""
case "${LANG:0:2}" in
     fr)echo -e "\t\e[33m\e[4m\e[1mCOMBINEUR D'ARCHIVES SFS, par musher0, 2018-04-05.\e[0m
\n\e[33mCombien de sfs voulez-vous combiner ?\e[0m"
     read combien
     echo -e "\n\e[33mEn voici la liste :\e[0m"
     ;;
     en|*)echo -e "\t\e[33m\e[4m\e[1mSFS ARCHIVES COMBINER, by musher0, 2018-04-05.\e[0m
\n\e[33mHow many sfs's do you wish to combine?\e[0m"
     read combien
     echo -e "\n\e[33mHere is the list:\e[0m"
     ;;
esac
ls -1 *.sfs | grep -v tentative | nl > fichiers;more fichiers

> liste.sfs
incorpor="";i="";i=1
echo;while [ "$i" -le "$combien" ]; do
case "${LANG:0:2}" in
     fr)echo -e "\e[33mS.v.p. taper le numéro d'un sfs à incorporer à partir de la liste ci-dessus :\e[0m"
     ;;
     en|*)echo -e "\e[33mPlease type the number of an sfs to incorporate from the list above:\e[0m"
     ;;
esac
     read incorpor
     awk '$1=='"$incorpor"' { print $2 }' fichiers >> liste.sfs
     i=$(($i + 1))
done

confirme="" # Vérif.
case "${LANG:0:2}" in
     fr)echo -e "\n\e[33mLes sfs suivants seront combinés. Est-ce bien ce que vous souhaitez ?
(Taper 'o' ou 'O' pour 'oui'; toute autre touche excepté 'y|Y' quitte.)\e[0m"
     ;;
     en|*)echo -e "\n\e[33mThe following sfs's will be combined. Is that your wish?
(Type 'y' or 'Y' for 'yes'; any other key except 'o|O' exits.)\e[0m"
     ;;
esac
more liste.sfs;read confirme

case "${confirme}" in y|Y|o|O) # Action
     case "${LANG:0:2}" in
          fr)echo -e "\n\e[33mTrès bien. Merci de patienter pendant que la combinaison se fait.\e[0m"
          ;;
          en|*)echo -e "\n\e[33mExcellent. Thanks for waiting while the chosen archives are combined.\e[0m"
          ;;
     esac
     while read line;do
          mkdir /mnt/zip/"${line:0:6}"
          mount $line /mnt/zip/"${line:0:6}"
     done < liste.sfs

     > /mnt/home/liste.rep
     cd /mnt/zip
     ls -1 >> /mnt/home/liste.rep
     while read line;do rsync -az /mnt/zip/$line/* /mnt/home/tentative
     wait
     done < /mnt/home/liste.rep

     cd /mnt/home
     mksquashfs tentative/ tentative.sfs -no-progress -all-root -noappend -b 1048576 -comp xz -Xdict-size 100% > mksquashfs.rpt &
     # Pour voir les détails de l'opération, s.v.p. ouvrir le fichier texte mksquashfs.rpt dans votre éditeur ou lisez-le avec more.
     # To see the details of the operation, please open the mksquashfs.rpt text file in your editor or read it with more.
     while pgrep mksquashfs &> /dev/null;do
     echo -en "\e[34m¤";sleep 0.5
     # Source de cette barre : réponse no 0 par « purushothaman poovai » à https://
# stackoverflow.com/questions/238073/how-to-add-a-progress-bar-to-a-shell-script#238094
done ;;

     *)exit ;;
esac
nettoie
rm -f /mnt/home/mnt-zip.lst;rm -f /mnt/home/fichiers
rm -f /mnt/home/liste.sfs;rm -f /mnt/home/liste.rep
case "${LANG:0:2}" in
     fr)echo -e "\n\e[0m
\e[33m\e[4mLa combinaison est terminée. Il ne vous reste qu'à
renommer l'archive sfs résultante « tentative.sfs »
et à la monter avec l'utilitaire « sfs_load ». N'oubliez
pas de démonter les sfs d'origine s'il y a lieu. \e[24m
\e[1m-- Je vous souhaite une excellente journée !\e[0m\n"
     ;;
     en|*)echo -e "\n\e[0m
\e[33m\e[4m
The combining operation is now done. What is left for you to
do is rename the resulting sfs archive 'tentative.sfs' and
mount it with the 'sfs_load' utility. Do not forget to unmount
the originating sfs's.\e[24m \e[1m-- Have a great day!\e[0m\n"
     ;;
esac
# set +xe
# LANG="$LANGvx" # for tests
read
